#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

#include <winsock.h>
#include <winsock2.h>
#include <sys/types.h>

#include <sqlite3.h>

#include <pthread.h>

#define NUM_THREADS     5
#define CHUNK_SIZE 512


/* SQLite3 callback function */
static int callback( void *NotUsed, int argc, char **argv, char **azColName )
{

	int i;

	for ( i = 0; i < argc; i++ )
	{

		printf("%s = %s\n", azColName[i], argv[i] ? argv[i] : NULL);

	}

	printf("\n");
	return 0;

}

/* Funkcja usuwajaca ( zerujaca ) do okreslonego znaku okreslona ilosc razy */
char stringRemoval( char * string, char target, int repeat )
{

	int x;
	x = 0;

	while ( repeat > 0 )
	{

		while ( string[x] != target )
		{

			string[x] = '0';
			x++;

		}

		string[x] = '0';

		--repeat;
		x = 0;
	}

}

/* Funkcja wyciagajaca ciag slow z string */
char *stringExtract( const char *const string, const char *const left, const char *const right )
{

	char  *head;
   	char  *tail;
    	size_t length;
    	char  *result;

    	if ((string == NULL) || (left == NULL) || (right == NULL))
        	return NULL;

	length = strlen(left);
    	head   = strstr(string, left);

	if (head == NULL)
        	return NULL;

	head += length;
    	tail  = strstr(head, right);

	if (tail == NULL)
        	return tail;

	length = tail - head;
    	result = malloc(1 + length);

	if (result == NULL)
        	return NULL;

	result[length] = '\0';
    	memcpy(result, head, length);

    	return result;

}

/* Funkcja zwracająca aktualny znaczik pierwszeg znaku w ciągu za zerami */
int stringPointer( const char *const string )
{

	int x = 0;

	while ( string[x] == '0' )
	{

		x++;

	}

	return x;

}


void output(char *str)
{
      FILE *fp = fopen("output.txt", "a+");
      fprintf(fp, "%s\n", str);
      fclose(fp);
}




int get_ip(char * hostname , char* ip)
{  struct hostent *he;
   struct in_addr **addr_list;
   int i;
   if ( (he = gethostbyname( hostname ) ) == NULL)
   {
     return 1;}
   addr_list = (struct in_addr **) he->h_addr_list;
    for(i = 0; addr_list[i] != NULL; i++)
    {   strcpy(ip , inet_ntoa(*addr_list[i]) );
        return 0;}
    return 1;
}

void sendData(int *dataFileTransferControl )
{

      /* Winsock2 */
        WSADATA wsaData;
        SOCKET sSocket;

        struct sockaddr_in server;

        char serverQuery[256];
        char serverReply[20000];

        int serverReplySize;

        int portAdress, ipOne, ipTwo, ipThree, ipFour;
        char ipAdress[31];


        while ( *dataFileTransferControl != -2 );

        while ( *dataFileTransferControl == -2 );
        ipOne = *dataFileTransferControl;
        *dataFileTransferControl = -1;

        while ( *dataFileTransferControl == -1 );
        ipTwo = *dataFileTransferControl;
        *dataFileTransferControl = -1;

        while ( *dataFileTransferControl == -1 );
        ipThree = *dataFileTransferControl;
        *dataFileTransferControl = -1;

        while ( *dataFileTransferControl == -1 );
        ipFour = *dataFileTransferControl;
        *dataFileTransferControl = -1;

        snprintf(ipAdress, 30, "%d.%d.%d.%d", ipOne, ipTwo, ipThree, ipFour );

        while ( *dataFileTransferControl == -1 );
        portAdress = *dataFileTransferControl;
        *dataFileTransferControl = -1;

        *dataFileTransferControl = -1;



	if ( WSAStartup( MAKEWORD( 2,2 ), &wsaData ) != 0 )
	{

		printf("\nPolaczenie nieudane :(\nBlad: %d", WSAGetLastError());
		return 1;

	}

	// Socket
	if ( ( sSocket = socket( AF_INET, SOCK_STREAM, 0 ) ) == INVALID_SOCKET )
	{

		printf("\nNieudalo sie nawiazac polaczenia przez gniazdo\nBlad: %d", WSAGetLastError());
		return 1;

	}


	server.sin_addr.s_addr = inet_addr( ipAdress );
	server.sin_family = AF_INET;
	server.sin_port = htons( portAdress );

	// Polaczenie z serwerem
	if ( connect( sSocket, ( struct sockAddresIn * ) &server, sizeof(server)  ) < 0 )
	{

		printf("\nPolaczenie z serwerem nieudane");
		return 1;

	}

	*dataFileTransferControl = 1;

	while ( *dataFileTransferControl != 2 );





	FILE * file_to_send;
    int ch;
    char toSEND[1];
    char remoteFILE[4096];
    int count1=1,count2=1, percent;
    char lfile = "test.db";

    file_to_send = fopen ("test.db","rb");

    char *buffer;
    char c;
    long fileSIZE;

	printf("\n\n\n\t--- Wysylanie ---\n\n\t           ");

    fseek (file_to_send, 0, SEEK_END);
    fileSIZE = ftell (file_to_send);
    rewind(file_to_send);



      percent = fileSIZE / 100;
    while((ch=getc(file_to_send))!=EOF){
        toSEND[0] = ch;
        send(sSocket, toSEND, 1, 0);
        if( count1 == count2 ) {
            printf("\b\b\b\b%3d%%",count1 / percent);
            count1+=percent;
        }
        count2++;

    }

    fclose(file_to_send);
    // Zamykam winsock
	closesocket(sSocket);
	WSACleanup();

}

int connectToFTP( int *dataFileTransferControl )
{

      /* Winsock2 */
        WSADATA wsaData;
        SOCKET sSocket;

        struct sockaddr_in server;
        struct hostent        *he;

        char hostname[256];
        char ftpUsername[256];
        char ftpPass[256];
        char ftpDirectory[1024];

        char serverQuery[256];
        char serverReply[20000];
		char returnCodeC[4];
		int returnCode;
        char *portAdress;
        char *ipOne, *ipTwo, *ipThree, *ipFour, *strHelp, strHelp1;
        char *portOne, *portTwo;
        int portOneNum, portTwoNum, portNum, i;

        int serverReplySize;

		printf("\n\n\t--- Konfiguracja FTP ---\n\n");

        if ( WSAStartup( MAKEWORD( 2,2 ), &wsaData ) != 0 )
        {

            printf("\nPolaczenie nieudane :(\nBlad: %d", WSAGetLastError());
            return 1;

        }

        // Socket
        if ( ( sSocket = socket( AF_INET, SOCK_STREAM, 0 ) ) == INVALID_SOCKET )
        {

            printf("\nNieudalo sie nawiazac polaczenia przez gniazdo\nBlad: %d", WSAGetLastError());
            return 1;

        }

        printf("\n\n %c%c Nazwa serwera\n %c\n %c%c%c%c> ", 218, 196, 179, 192, 196, 196, 196);
        scanf("%s", &hostname);

        char ip[100];

        get_ip(hostname , ip);

        server.sin_addr.s_addr = inet_addr(ip);
        server.sin_family = AF_INET;
        server.sin_port = htons( 21 );

        // Polaczenie z serwerem
        if ( connect( sSocket, ( struct sockAddresIn * ) &server, sizeof(server)  ) < 0 )
        {

            printf("\nPolaczenie z serwerem nieudane");
            return 1;

        }

        *dataFileTransferControl = 1;

        if ( ( serverReplySize = recv( sSocket, serverReply, 20000, 0 ) ) == SOCKET_ERROR )
        {

            printf("\nBlad otrzymywania odpowiedzi od serwera.");
            return 1;

        }

        // Zakonczenie odpowiedzi
        serverReply[serverReplySize] = '\0';

		printf(" %c%c> OK!", 192, 196);

		returnCode = 530;

        // Logowanie
		while ( returnCode == 530 )
		{


			printf("\n\n %c%c Login\n %c\n %c%c%c%c> ", 218, 196, 179, 192, 196, 196, 196);
			scanf("%s", &ftpUsername);

			// Użytkownik
			sprintf(serverQuery, "USER %s\r\n", ftpUsername);

			if ( send( sSocket, serverQuery, strlen(serverQuery), 0 ) < 0 )
			{

				printf("\nWysylanie zapytania zakonczone niepowodzeniem. Przykro mi. Sprobuj jeszcze raz.");
				return 1;

			}

			if ( ( serverReplySize = recv( sSocket, serverReply, 20000, 0 ) ) == SOCKET_ERROR )
			{

				printf("\nBlad otrzymywania odpowiedzi od serwera.");
				return 1;

			}

			// Zakonczenie odpowiedzi
			serverReply[serverReplySize] = '\0';

			printf(" %c%c> OK!", 192, 196);
			


			printf("\n\n %c%c Haslo\n %c\n %c%c%c%c> ", 218, 196, 179, 192, 196, 196, 196);
			
			i = 0;
			char c;

			while ( i < 255 )
			{

				c = getch();

				if ( c == 13 || c == 10 )
				{
					break;
				}
				else
				{

					if ( c == 8 || c == '\b' )
					{ 
						if ( i > 0 ) i--, printf("\b \b");
					}
					else
					{

						ftpPass[i] = c;
						i++;
						printf("*");

					}
				}

			}

			ftpPass[i] = '\0';
			
			//scanf("%s", &ftpPass);



			// Hasło
			sprintf(serverQuery, "PASS %s\r\n", ftpPass);

			if ( send( sSocket, serverQuery, strlen(serverQuery), 0 ) < 0 )
			{

				printf("\nWysylanie zapytania zakonczone niepowodzeniem. Przykro mi. Sprobuj jeszcze raz.");
				return 1;

			}

			if ( ( serverReplySize = recv( sSocket, serverReply, 20000, 0 ) ) == SOCKET_ERROR )
			{

				printf("\nBlad otrzymywania odpowiedzi od serwera.");
				return 1;

			}

			// Zakonczenie odpowiedzi
			serverReply[serverReplySize] = '\0';
			
			returnCodeC[0] = serverReply[0];
			returnCodeC[1] = serverReply[1];
			returnCodeC[2] = serverReply[2];
			returnCodeC[3] = '\0';

			returnCode = atoi( returnCodeC );

			if ( returnCode == 530 ) printf("\n\n %c%c%c%c%c> Blad! Zle haslo lub login.", 196, 196, 196, 196, 196);
			else printf("\n %c%c> OK!", 192, 196);

		}


		printf("\n\n> Polaczono!");













		// Get current directory
        sprintf(serverQuery, "PWD\r\n");

        if ( send( sSocket, serverQuery, strlen(serverQuery), 0 ) < 0 )
        {

            printf("\nWysylanie zapytania zakonczone niepowodzeniem. Przykro mi. Sprobuj jeszcze raz.");
            return 1;

        }

        if ( ( serverReplySize = recv( sSocket, serverReply, 20000, 0 ) ) == SOCKET_ERROR )
        {

            printf("\nBlad otrzymywania odpowiedzi od serwera.");
            return 1;

        }

        // Zakonczenie odpowiedzi
        serverReply[serverReplySize] = '\0';

        printf("\n\nAktualna sciezka: %s", stringExtract( serverReply, "\"", "\"" ));





		int goNext = 0;

		while ( goNext == 0 )
		{


			printf("\n\nPodaj sciezke do zapisu pliku: ");
			scanf("%s", &ftpDirectory);


			// Get current directory
			sprintf(serverQuery, "CWD %s\r\n", ftpDirectory);

			if ( send( sSocket, serverQuery, strlen(serverQuery), 0 ) < 0 )
			{

				printf("\nWysylanie zapytania zakonczone niepowodzeniem. Przykro mi. Sprobuj jeszcze raz.");
				return 1;

			}

			if ( ( serverReplySize = recv( sSocket, serverReply, 20000, 0 ) ) == SOCKET_ERROR )
			{

				printf("\nBlad otrzymywania odpowiedzi od serwera.");
				return 1;

			}

			// Zakonczenie odpowiedzi
			serverReply[serverReplySize] = '\0';





		





			// Get current directory
			sprintf(serverQuery, "PWD\r\n");

			if ( send( sSocket, serverQuery, strlen(serverQuery), 0 ) < 0 )
			{

				printf("\nWysylanie zapytania zakonczone niepowodzeniem. Przykro mi. Sprobuj jeszcze raz.");
				return 1;

			}

			if ( ( serverReplySize = recv( sSocket, serverReply, 20000, 0 ) ) == SOCKET_ERROR )
			{

				printf("\nBlad otrzymywania odpowiedzi od serwera.");
				return 1;

			}

			// Zakonczenie odpowiedzi
			serverReply[serverReplySize] = '\0';

        	printf("\n\nAktualna sciezka: %s", stringExtract( serverReply, "\"", "\"" ));
			printf("\n\nCzy chcesz zmienic sciezke? ( TAK = 0, NIE = 1 ): ");
			scanf("%d", &goNext);




		}



        // Get current directory
        sprintf(serverQuery, "TYPE I\r\n");

        if ( send( sSocket, serverQuery, strlen(serverQuery), 0 ) < 0 )
        {

            printf("\nWysylanie zapytania zakonczone niepowodzeniem. Przykro mi. Sprobuj jeszcze raz.");
            return 1;

        }

        if ( ( serverReplySize = recv( sSocket, serverReply, 20000, 0 ) ) == SOCKET_ERROR )
        {

            printf("\nBlad otrzymywania odpowiedzi od serwera.");
            return 1;

        }

        // Zakonczenie odpowiedzi
        serverReply[serverReplySize] = '\0';



















        // Change port to send file
        sprintf(serverQuery, "PASV\r\n");

        if ( send( sSocket, serverQuery, strlen(serverQuery), 0 ) < 0 )
        {

            printf("\nWysylanie zapytania zakonczone niepowodzeniem. Przykro mi. Sprobuj jeszcze raz.");
            return 1;

        }

        if ( ( serverReplySize = recv( sSocket, serverReply, 20000, 0 ) ) == SOCKET_ERROR )
        {

            printf("\nBlad otrzymywania odpowiedzi od serwera.");
            return 1;

        }

        // Zakonczenie odpowiedzi
        serverReply[serverReplySize] = '\0';

        i = 0;


        *dataFileTransferControl = -2;
        // Getting server IP
        ipOne = stringExtract( serverReply, "(", "," );
        *dataFileTransferControl = atoi(ipOne);

        while ( *dataFileTransferControl == -1 );

        while ( serverReply[i] != ',' ) serverReply[i] = '0', i++;

        ipTwo = stringExtract( serverReply, "," , "," );

        *dataFileTransferControl = atoi(ipTwo);

        while ( *dataFileTransferControl == -1 );

        serverReply[i] = '0'; i++;

        while ( serverReply[i] != ',' ) serverReply[i] = '0', i++;

        ipThree = stringExtract( serverReply, ",", "," );

        *dataFileTransferControl = atoi(ipThree);

        while ( *dataFileTransferControl == -1 );

        serverReply[i] = '0'; i++;

        while ( serverReply[i] != ',' ) serverReply[i] = '0', i++;

        ipFour = stringExtract( serverReply, ",", "," );

        *dataFileTransferControl = atoi(ipFour);

        while ( *dataFileTransferControl == -1 );


        // Getting IP adress of server passive mode into one string
        strcat( ipOne, "." );
        strcat( ipOne, ipTwo );
        strcat( ipOne, "." );
        strcat( ipOne, ipThree );
        strcat( ipOne, "." );
        strcat( ipOne, ipFour );


        // Getting port adress
        serverReply[i] = '0'; i++;

        while ( serverReply[i] != ',' ) serverReply[i] = '0', i++;

        portOne = stringExtract( serverReply, ",", "," );

        serverReply[i] = '0'; i++;

        while ( serverReply[i] != ',' ) serverReply[i] = '0', i++;

        portTwo = stringExtract( serverReply, ",", ")" );

        portOneNum = atoi(portOne);
        portTwoNum = atoi(portTwo);

        portNum = portOneNum*256+portTwoNum;

        *dataFileTransferControl = portNum;

        while ( *dataFileTransferControl != -1 );

        *dataFileTransferControl = 2;

        while ( *dataFileTransferControl != 1 );

        // Użytkownik
        sprintf(serverQuery, "STOR test.db\r\n");

        if ( send( sSocket, serverQuery, strlen(serverQuery), 0 ) < 0 )
        {

            printf("\nWysylanie zapytania zakonczone niepowodzeniem. Przykro mi. Sprobuj jeszcze raz.");
            return 1;

        }

         if ( ( serverReplySize = recv( sSocket, serverReply, 20000, 0 ) ) == SOCKET_ERROR )
        {

            printf("\nBlad otrzymywania odpowiedzi od serwera.");
            return 1;

        }

        // Zakonczenie odpowiedzi
        serverReply[serverReplySize] = '\0';

        *dataFileTransferControl = 2;


                 if ( ( serverReplySize = recv( sSocket, serverReply, 20000, 0 ) ) == SOCKET_ERROR )
        {

            printf("\nBlad otrzymywania odpowiedzi od serwera.");
            return 1;

        }

        // Zakonczenie odpowiedzi
        serverReply[serverReplySize] = '\0';


        closesocket(sSocket);
        WSACleanup();

}


int main(  )
{

	/* Zmienne */
	int i,x,y,z;

	int srPointer; // Server Reply Pointer

	int pointersDay, pointersHour, pointersClassID;

	unsigned int percentAll, percentComplete, percentIndicator;

	percentAll = 0;
	percentComplete = 0;
	percentIndicator = 0;

	char *extractedData;
    char *extractedData_1;
	char *extractedData_2;

	char pointersClassNameOne[50];
	char pointersClassNameTwo[50];
	char pointersClassNameThr[50];

	char *pointersLesson;
	char *pointersGroup;
	char *pointersClass;
	char pointersClassName[4];
	char *pointersRoom;
	char *pointersTeacher;

	/* Winsock2 */
	WSADATA wsaData;
	SOCKET sSocket;

	struct sockaddr_in server;

	char serverQuery[256];
	char serverReply[20000];

	int serverReplySize;

	/* SQLite3 */
	sqlite3 *dataBase;

	int remoteConnection;

	char *sql;
	char *sqlErrorMessage = 0;





















	/*
	 *
	 *	Inicjalizacja winsock2
	 *
	 */

	printf("\nInicjalizacja Winsock2...");

	if ( WSAStartup( MAKEWORD( 2,2 ), &wsaData ) != 0 )
	{

		printf("\nPolaczenie nieudane :(\nBlad: %d", WSAGetLastError());
		return 1;

	}

	// Socket
	if ( ( sSocket = socket( AF_INET, SOCK_STREAM, 0 ) ) == INVALID_SOCKET )
	{

		printf("\nNieudalo sie nawiazac polaczenia przez gniazdo\nBlad: %d", WSAGetLastError());
		return 1;

	}

	printf("\nLaczenie z gornik.tbg.net.pl...");

	server.sin_addr.s_addr = inet_addr("91.240.28.195");
	server.sin_family = AF_INET;
	server.sin_port = htons( 80 );

	// Polaczenie z serwerem
	if ( connect( sSocket, ( struct sockAddresIn * ) &server, sizeof(server)  ) < 0 )
	{

		printf("\nPolaczenie z serwerem nieudane");
		return 1;

	}








	/*
	 *
	 *	Wysylanie zadania HHTP i pobieranie danych na temat klas, sal itp.
	 */


	printf("\nWysylanie zadania HTTP...");

	sprintf(serverQuery, "GET /info/plan_lekcji/lista.html HTTP/1.1\r\nhost: gornik.tbg.net.pl\r\n\r\n\r\n");

	if ( send( sSocket, serverQuery, strlen(serverQuery), 0 ) < 0 )
	{

		printf("\nWysylanie zapytania zakonczone niepowodzeniem. Przykro mi. Sprobuj jeszcze raz.");
		return 1;

	}

	// Otrzymanie odpowiedzi z serwera
	if ( ( serverReplySize = recv( sSocket, serverReply, 20000, 0 ) ) == SOCKET_ERROR )
	{

		printf("\nBlad otrzymywania odpowiedzi od serwera.");
		return 1;

	}

	// Zakonczenie odpowiedzi
	serverReply[serverReplySize] = '\0';

	// Zamykam winsock
	closesocket(sSocket);
	WSACleanup();

	// Przygotowanie do przechwytywania danych
	stringRemoval( serverReply, '\n', 21 );

	/*
	 *
	 *	Otwieranie bazy danych sqlite
	 *
	 * */


	printf("\nOtwieranie bazy danych...");

	remoteConnection = sqlite3_open("test.db", &dataBase);

	if ( remoteConnection )
	{

		fprintf( stderr, "Nie mozna otworzyc bazy danych :(\nBlad: %d", WSAGetLastError() );
		return 1;

	}

	/*
	 *
	 *	Czyszczenie bazy danych
	 *
	 * */


	printf("\nCzyszczenie baz danych...");

	// Klasy
	sql = sqlite3_mprintf( "DELETE from CLASSES" );
	remoteConnection = sqlite3_exec( dataBase, sql, callback, 0, &sqlErrorMessage );

	if ( remoteConnection != SQLITE_OK )
	{

		sqlite3_free(sqlErrorMessage);

	}

	// Godziny
	sql = sqlite3_mprintf( "DELETE from HOUR" );
	remoteConnection = sqlite3_exec( dataBase, sql, callback, 0, &sqlErrorMessage );

	if ( remoteConnection != SQLITE_OK )
	{

		sqlite3_free(sqlErrorMessage);

	}

	// Sale
	sql = sqlite3_mprintf( "DELETE from SALE" );
	remoteConnection = sqlite3_exec( dataBase, sql, callback, 0, &sqlErrorMessage );

	if ( remoteConnection != SQLITE_OK )
	{

		sqlite3_free(sqlErrorMessage);

	}

	// Nauczyciele
	sql = sqlite3_mprintf( "DELETE from TEACHER" );
	remoteConnection = sqlite3_exec( dataBase, sql, callback, 0, &sqlErrorMessage );

	if ( remoteConnection != SQLITE_OK )
	{

		sqlite3_free(sqlErrorMessage);

	}

	// Data
	sql = sqlite3_mprintf( "DELETE from DATA_TABLE" );
	remoteConnection = sqlite3_exec( dataBase, sql, callback, 0, &sqlErrorMessage );

	if ( remoteConnection != SQLITE_OK )
	{

		sqlite3_free(sqlErrorMessage);

	}











	/*
	 *
	 *	Uzupelnianie bazy danych
	 *
	 * */

	// Klasy
	printf("\nAktualizowanie bazy danych: Klasy...");

	extractedData = stringExtract( serverReply, ">", "</" );
	extractedData_1 = stringExtract( serverReply, "=\"", "\">" );

	while ( extractedData[3] != 's' )
	{

		if ( extractedData != NULL )
		{

			x = atoi( extractedData_1 );

			percentAll++;

            pointersClassNameOne[x] = extractedData[0];
            pointersClassNameTwo[x] = extractedData[1];

            if ( strlen( extractedData ) == 3 ) pointersClassNameThr[x] = extractedData[2];
            else pointersClassNameThr[x] = ' ';

			sql = sqlite3_mprintf(  "INSERT INTO CLASSES (ID, ODDZIAL, WYCHOWAWCA, GRUPA) " \
						"VALUES (%d, '%q', 0, 0); ", x, extractedData );

			remoteConnection = sqlite3_exec( dataBase, sql, callback, 0, &sqlErrorMessage );
			if ( remoteConnection != SQLITE_OK )
			{

				sqlite3_free(sqlErrorMessage);
				printf("\n\n\t\tBlad krytyczny");
				return 1;

			}

		}

		free(extractedData);
		free(extractedData_1);

		stringRemoval( serverReply, '\n', 1 );

		extractedData = stringExtract( serverReply, ">", "</" );
		extractedData_1 = stringExtract( serverReply, "=\"", "\">" );

	}

	percentAll = percentAll*45;





	// Godziny
	printf("\nAktualizowanie bazy danych: Godziny...");

	sql = sqlite3_mprintf(  "INSERT INTO HOUR (ID,START,STOP) "  \
							"VALUES (1, '7:10', '7:55' ); " \
							"INSERT INTO HOUR (ID,START,STOP) "  \
							"VALUES (2, '8:00', '8:45' ); " \
							"INSERT INTO HOUR (ID,START,STOP)" \
							"VALUES (3, '8:55', '9:40' ); " \
							"INSERT INTO HOUR (ID,START,STOP)" \
							"VALUES (4, '9:45', '10:30' ); " \
							"INSERT INTO HOUR (ID,START,STOP)" \
							"VALUES (5, '10:45', '11:30' ); " \
							"INSERT INTO HOUR (ID,START,STOP)" \
							"VALUES (6, '11:35', '12:20' ); " \
							"INSERT INTO HOUR (ID,START,STOP)" \
							"VALUES (7, '12:30', '13:15' ); " \
							"INSERT INTO HOUR (ID,START,STOP)" \
							"VALUES (8, '13:20', '14:05' ); " \
							"INSERT INTO HOUR (ID,START,STOP)" \
							"VALUES (9, '14:10', '14:55' ); " \
							"INSERT INTO HOUR (ID,START,STOP)" \
							"VALUES (10, '0:00', '0:00' );" );

	remoteConnection = sqlite3_exec( dataBase, sql, callback, 0, &sqlErrorMessage );
	if ( remoteConnection != SQLITE_OK )
	{

		sqlite3_free(sqlErrorMessage);
		printf("\n\n\t\tBlad krytyczny");
		return 1;

	}




	// Nauczyciele
	printf("\nAktualizowanie bazy danych: Nauczyciele...");

	stringRemoval( serverReply, '\n', 3 );

	extractedData = stringExtract( serverReply, ">", "</" );
	extractedData_1 = stringExtract( serverReply, "=\"", "\">" );
	extractedData_2 = stringExtract( extractedData, "(", ")" );

	while ( extractedData[2] != '<' )
	{

		if ( extractedData != NULL )
		{

			x = atoi( extractedData_1 );

			extractedData = stringExtract( extractedData, "", " (" );

			sql = sqlite3_mprintf(  "INSERT INTO TEACHER (ID, SKROT, NAZWISKO) " \
						"VALUES (%d, '%q', '%q'); ", x, extractedData_2, extractedData );

			remoteConnection = sqlite3_exec( dataBase, sql, callback, 0, &sqlErrorMessage );
			if ( remoteConnection != SQLITE_OK )
			{

				sqlite3_free(sqlErrorMessage);
				printf("\n\n\t\tBlad krytyczny");
				return 1;

			}

		}

		free(extractedData);
		free(extractedData_1);
		free(extractedData_2);

		stringRemoval( serverReply, '\n', 1 );

		extractedData = stringExtract( serverReply, ">", "</" );
		extractedData_1 = stringExtract( serverReply, "=\"", "\">" );
		extractedData_2 = stringExtract( extractedData, "(", ")" );

	}





	// Sale
	printf("\nAktualizowanie bazy danych: Sale...");

	stringRemoval( serverReply, '\n', 3 );

	extractedData = stringExtract( serverReply, ">", "/" );
	extractedData_1 = stringExtract( serverReply, "=\"", "\">" );
	extractedData_2 = stringExtract( extractedData, "", " " );

	while ( extractedData_1 != 0 )
	{

		if ( extractedData != NULL )
		{

			x = atoi( extractedData_1 );

			extractedData = stringExtract( extractedData, " ", "<" );

			sql = sqlite3_mprintf(  "INSERT INTO SALE (ID, NUMER, OPIEKUN) " \
						"VALUES (%d, '%q', '%q'); ", x, extractedData_2, extractedData );

			remoteConnection = sqlite3_exec( dataBase, sql, callback, 0, &sqlErrorMessage );
			if ( remoteConnection != SQLITE_OK )
			{

				sqlite3_free(sqlErrorMessage);
				printf("\n\n\t\tBlad krytyczny");
				return 1;

			}

		}

		free(extractedData);
		free(extractedData_1);
		free(extractedData_2);



		stringRemoval( serverReply, '\n', 1 );

		extractedData = stringExtract( serverReply, ">", "/" );
		extractedData_1 = stringExtract( serverReply, "=\"", "\">" );
		extractedData_2 = stringExtract( extractedData, "", " " );

	}

    sqlite3_close(dataBase);


	/*
	***************************************************************************************************************************************************************************
	*/

	printf("\n\n\t--- Aktualizacja ---\n\n\t          0 ");

	for ( pointersClassID = 1; pointersClassID < 25; pointersClassID++ )
	{

		if ( pointersClassID == 9 ) pointersClassID = 15;

        pointersClassName[0] = pointersClassNameOne[pointersClassID];
        pointersClassName[1] = pointersClassNameTwo[pointersClassID];
        pointersClassName[2] = pointersClassNameThr[pointersClassID];
        pointersClassName[3] = '\0';


		/*
		*
		*	Inicjalizacja winsock2
		*
		* */
		if ( WSAStartup( MAKEWORD( 2,2 ), &wsaData ) != 0 )
		{

			printf("\nPolaczenie nieudane :(\nBlad: %d", WSAGetLastError());
			return 1;

		}

		// Socket
		if ( ( sSocket = socket( AF_INET, SOCK_STREAM, 0 ) ) == INVALID_SOCKET )
		{

			printf("\nNieudalo sie nawiazac polaczenia przez gniazdo\nBlad: %d", WSAGetLastError());
			return 1;

		}

		server.sin_addr.s_addr = inet_addr("91.240.28.195");
		server.sin_family = AF_INET;
		server.sin_port = htons( 80 );

		// Polaczenie z serwerem
		if ( connect( sSocket, ( struct sockAddresIn * ) &server, sizeof(server)  ) < 0 )
		{

			printf("\nPolaczenie z serwerem nieudane");
			return 1;

		}

		/*
		*
		*	Wysylanie zadania HHTP i pobieranie danych dla danego oddziału
		*
		* */

		sprintf( serverQuery, "GET /info/plan_lekcji/plany/o%d.html HTTP/1.1\r\nhost: gornik.tbg.net.pl\r\n\r\n\r\n", pointersClassID);

		if ( send( sSocket, serverQuery, strlen(serverQuery), 0 ) < 0 )
		{

			printf("\nWysylanie zapytania zakonczone niepowodzeniem. Przykro mi. Sprobuj jeszcze raz.");
			return 1;

		}

		// Otrzymanie odpowiedzi z serwera
		if ( ( serverReplySize = recv( sSocket, serverReply, 20000, 0 ) ) == SOCKET_ERROR )
		{

			printf("\nBlad otrzymywania odpowiedzi od serwera.");
			return 1;

		}

		// Zakonczenie odpowiedzi
		serverReply[serverReplySize] = '\0';

		// Zamykam winsock
		closesocket(sSocket);
		WSACleanup();


		// Otwieranie bazy danych sqlite3
        remoteConnection = sqlite3_open("test.db", &dataBase);

        if ( remoteConnection )
        {

            fprintf( stderr, "Nie mozna otworzyc bazy danych :(\nBlad: %d", WSAGetLastError() );
            return 1;

        }

		stringRemoval( serverReply, '\n', 40 );
		stringRemoval( serverReply, '>', 1 );


		// Godziny
		for ( pointersHour = 1; pointersHour < 11; pointersHour++ )
		{


			// Dni
			for ( pointersDay = 1; pointersDay < 6; pointersDay++ )
			{


				if ( serverReply[( srPointer = stringPointer( serverReply ) )] != '&' )
				{

					pointersGroup = "0";
					pointersRoom = "0";






					/*
					****************************************************************************************************************************************************************************
					*/












					if ( serverReply[srPointer+14] != '"' ) stringRemoval( serverReply, '>', 1 );

						//printf( "%s", serverReply );

						pointersLesson = stringExtract( serverReply, ">", "</" );
						stringRemoval( serverReply, '>', 2 );

						extractedData = stringExtract( serverReply, ">", "</" );

						// Jeśli 1 znak to #
						if ( extractedData[0] == '#' ) pointersGroup = stringExtract( serverReply, ">", "</" );
						else pointersTeacher = stringExtract( serverReply, ">", "</" );

						free( extractedData );
						stringRemoval( serverReply, '>', 2 );

						//printf("%s", serverReply);

						// Sprawdzam czy to już koniec pierwszego wiersza w I tabeli
						if ( serverReply[ ( srPointer = stringPointer( serverReply ) ) + 2 ] == '/'  || serverReply[ ( srPointer = stringPointer( serverReply ) ) + 4 ] == '>' )
						{

							/*
								Tutaj jest już koniec sprawdzania nie ma więcej inforamcji do pobrania
								jeśli są to kontynuuje szukanie w else V V V
							*/
							sql = sqlite3_mprintf(  "INSERT INTO DATA_TABLE (KLASA, SALA, NAUCZYCIEL, ODDZIAL, GRUPA, DZIEN, GODZINA, LEKCJA) " \
                                        "VALUES (%d, '%q', '%q', '%q', '%q', %d, %d, '%q'); ", pointersClassID, pointersRoom, pointersTeacher, pointersClassName, pointersGroup, pointersDay, pointersHour, pointersLesson );

                            remoteConnection = sqlite3_exec( dataBase, sql, callback, 0, &sqlErrorMessage );
                            if ( remoteConnection != SQLITE_OK )
                            {

                                sqlite3_free(sqlErrorMessage);
                                printf("\n\n\t\tBlad krytyczny");
                                return 1;

                            }

						}
						else
						{

							/*
								Kontynuuje szukanie nowych informacji
							*/

							// Zawsze zostanie tutaj sala jeśli doszło do tego miejsca
							pointersRoom = stringExtract( serverReply, ">", "</" );


							sql = sqlite3_mprintf(  "INSERT INTO DATA_TABLE (KLASA, SALA, NAUCZYCIEL, ODDZIAL, GRUPA, DZIEN, GODZINA, LEKCJA) " \
                                        "VALUES (%d, '%q', '%q', '%q', '%q', %d, %d, '%q'); ", pointersClassID, pointersRoom, pointersTeacher, pointersClassName, pointersGroup, pointersDay, pointersHour, pointersLesson );

                            remoteConnection = sqlite3_exec( dataBase, sql, callback, 0, &sqlErrorMessage );
                            if ( remoteConnection != SQLITE_OK )
                            {

                                sqlite3_free(sqlErrorMessage);
                                printf("\n\n\t\tBlad krytyczny");
                                return 1;

                            }

						}

						//printf("\n\nZNAK: %c%c%c%c\n\n", serverReply[ ( stringPointer( serverReply ) ) + 44 ], serverReply[ ( stringPointer( serverReply ) ) + 45 ], serverReply[ ( stringPointer( serverReply ) ) + 46 ], serverReply[ ( stringPointer( serverReply ) ) + 47 ]);

						free( pointersLesson );
						free( pointersTeacher );
						free( pointersGroup );


						//printf("%s", serverReply);

						if ( serverReply[ ( stringPointer( serverReply ) ) + 44 ] == 'b' && serverReply[ ( stringPointer( serverReply ) ) + 45 ] == 'r' )
						{

							stringRemoval( serverReply, '>', 3 );
							serverReply[ ( stringPointer( serverReply ) ) ] = '\n';
							--pointersDay;

						}
						else if ( serverReply[ ( stringPointer( serverReply ) ) + 44 ] == 'n' )
						{

							stringRemoval( serverReply, '>', 2 );
							serverReply[ ( stringPointer( serverReply ) ) ] = '\n';
							--pointersDay;

						}







					/*
					*
					****************************************************************************************************************************************************************************
					*
					*/















				}

				stringRemoval( serverReply, '\n', 1 );
				stringRemoval( serverReply, '>', 1 );

				percentComplete++;

				percentIndicator = ( ( percentComplete*100 ) / percentAll );

				if ( percentIndicator > 100 ) percentIndicator = 100;

				printf("\b\b\b\b%3d%c", percentIndicator, 37);

			} // Godziny

			//printf("%s", serverReply);
			if ( serverReply[ ( stringPointer( serverReply ) ) + 3 ] == '/' ) pointersHour = 100, pointersDay = 100;

			stringRemoval( serverReply, '\n', 4 );
			stringRemoval( serverReply, '>', 1 );


		} // Dni

		sqlite3_close(dataBase);

	}




	percentIndicator = 100;
    printf("\b\b\b\b%3d%c", percentIndicator, 37);





    /*
    *****************************************************************************************************************************
    *****************************************************************************************************************************

        FTP

    */

		printf("\n\n");

		printf("\t*******  *******  *******\n");
		printf("\t*           *     *     *\n");
		printf("\t*           *     *     *\n");
		printf("\t*           *     *     *\n");
		printf("\t******      *     *******\n");
		printf("\t*           *     *      \n");
		printf("\t*           *     *      \n");
		printf("\t*           *     *      \n");
		printf("\t*           *     *      \n");
		printf("\t*           *     *      \n");

        int dataFileTransferControl = 1;

		printf( "\n\n\n" );

		if ( dataFileTransferControl == 1 ) printf("Data File Transfer Control: GOTOWY");

        int portNumber, isEverythingReady;
        char ipAdress;

        isEverythingReady = 0;
        portNumber = 0;

        pthread_t thread1, thread2;

        pthread_create(&thread1, NULL, connectToFTP, &dataFileTransferControl);

        pthread_create(&thread2, NULL, sendData, &dataFileTransferControl);


        pthread_join(thread2, NULL);

        pthread_join(thread1, NULL);




    printf("\n\n\n\t  --- KONIEC ---\n\n\n");

    return 1;

}


